<template>
  <PageCard
    class="signIn_wrapper"
    gradient
    :title="$t('authorization.step3.part2.scan')"
    :bordering="false">
    <div class="signIn_inner">
      <div
        class="signIn_inner-body flex flex-center"
        style="height: 100%; width: 100%; min-height: 140px;">
        <h2
          v-if="disable"
          class="step3_part2-qr-btn"
          style="max-width: 200px;">Camera is not available in your browser</h2>
        <h2
          v-if="disabledScanner"
          class="step3_part2-qr-btn"
          style="max-width: 200px;">QR Scanner is not available in your device</h2>
        <img
          v-if="!disable && !streaming && !disabledScanner"
          class="signIn_inner-body-qr"
          src="~/static/icons/scan.png"
          alt="">
        <video
          v-if="!disable && !disabledScanner"
          ref="video"
          muted
          playsinline
          style="height: 100%; width: 100%; min-height: 200px">
          &lt;!&ndash;<div class="step3_part2-backgrounds-blur"></div>&ndash;&gt;
        </video>
      </div>
      <div class="flex flex_column flex-middle" v-if="!disable && !disabledScanner">
        <img
          class="icon mt-20"
          src="~/static/icons/camera.png"
          alt="">
        <BSwitch
          class="mt-10"
          @change="change"
          :checked="streaming"
          :activeText="$t('common.off')"
          :inactiveText="$t('common.on')"></BSwitch>
      </div>
    </div>
  </PageCard>
</template>

<script>
  import BtnDark from '~/components/UI/BtnSign_dark';
  import BSwitch from '~/components/UI/Switch';
  import PageCard from '~/components/UI/PageCard';
  import QrScanner from 'qr-scanner';

  QrScanner.WORKER_PATH = './qr-scanner-worker.min.js';
  import {Wallet} from '~/services/wallet/';
  import MobileDetect from 'mobile-detect';

  export default {
    name: "Step3_ThePart2",
    props: {
      active: {
        type: Boolean,
        default: false
      }
    },
    data() {
      return {
        height: null,
        defaultHeight: 318,
        collapsed: true,
        qrScanner: null,
        streaming: false,
        disable: false,
        disabledScanner: false
      }
    },
    components: {
      BSwitch,
      BtnDark,
      PageCard
    },
    computed: {},
    methods: {
      change() {
        if (!this.streaming) {
          this.start();
        } else {
          this.stop();
        }
      },
      async start() {
        try {
          await this.qrScanner.start();
          this.streaming = true;
        } catch (e) {
          this.streaming = false;
        }
      },
      stop() {
        this.qrScanner && this.qrScanner.stop();
        this.streaming = false;
      },
      checkKeys(keys) {
        try {
          const privateKeys = keys.split(':');
          if (!Wallet.isValidPrivate(privateKeys)) {
            return;
          }
          const publicKeys = Wallet.privateToPublic(privateKeys);
          this.$emit('finish', {
            privateKeys,
            publicKeys
          });
        } catch (e) {
          console.log('error check keys- ', e);
        }
      }
    },
    beforeDestroy() {
      this.stop();
      this.qrScanner && this.qrScanner.destroy();
      this.qrScanner = null;
    },
    mounted() {
      const md = new MobileDetect(navigator.userAgent);
      if (md.is('iPhone')) {
        this.disabledScanner = true;
      } else {
        if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
          this.qrScanner = new QrScanner(this.$refs['video'], keys => {
            this.stop();
            this.checkKeys(keys)
          });
        } else {
          this.disable = true;
        }
      }
    }
  }
</script>
